## MmGdbusModemOma MmGdbusModemOma — Generated C code for the org.freedesktop.ModemManager1.Modem.Oma D-Bus interface |

## Functions

void | mm_gdbus_modem_oma_call_accept_network_initiated_session ()
gboolean | mm_gdbus_modem_oma_call_accept_network_initiated_session_finish ()
gboolean | mm_gdbus_modem_oma_call_accept_network_initiated_session_sync ()
void | mm_gdbus_modem_oma_call_cancel_session ()
gboolean | mm_gdbus_modem_oma_call_cancel_session_finish ()
gboolean | mm_gdbus_modem_oma_call_cancel_session_sync ()
void | mm_gdbus_modem_oma_call_setup ()
gboolean | mm_gdbus_modem_oma_call_setup_finish ()
gboolean | mm_gdbus_modem_oma_call_setup_sync ()
void | mm_gdbus_modem_oma_call_start_client_initiated_session ()
gboolean | mm_gdbus_modem_oma_call_start_client_initiated_session_finish ()
gboolean | mm_gdbus_modem_oma_call_start_client_initiated_session_sync ()
guint | mm_gdbus_modem_oma_get_features ()
gint | mm_gdbus_modem_oma_get_session_state ()
guint | mm_gdbus_modem_oma_get_session_type ()
GVariant * | mm_gdbus_modem_oma_get_pending_network_initiated_sessions ()
GVariant * | mm_gdbus_modem_oma_dup_pending_network_initiated_sessions ()

## Properties

guint | features | Read / Write
GVariant * | pending-network-initiated-sessions | Read / Write
int | session-state | Read / Write
guint | session-type | Read / Write

## Signals

gboolean | handle-accept-network-initiated-session | Run Last
gboolean | handle-cancel-session | Run Last
gboolean | handle-setup | Run Last
gboolean | handle-start-client-initiated-session | Run Last
void | session-state-changed | Run Last

## Types and Values

| MmGdbusModemOma
struct | MmGdbusModemOmaIface

## Object Hierarchy

        GInterface
        ╰── MmGdbusModemOma

## Prerequisites

MmGdbusModemOma requires GObject.

## Known Implementations

MmGdbusModemOma is implemented by MMModemOma, MmGdbusModemOmaProxy and MmGdbusModemOmaSkeleton.

## Description

This section contains code for working with the org.freedesktop.ModemManager1.Modem.Oma D-Bus interface in C.

## Functions

### mm_gdbus_modem_oma_call_accept_network_initiated_session ()

    void
    mm_gdbus_modem_oma_call_accept_network_initiated_session
                                   (MmGdbusModemOma *proxy,
                                    guint arg_session_id,
                                    gboolean arg_accept,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `AcceptNetworkInitiatedSession()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_oma_call_accept_network_initiated_session_finish()` to get the result of the operation.

See `mm_gdbus_modem_oma_call_accept_network_initiated_session_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_session_id | Argument to pass with the method invocation. |
arg_accept | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_oma_call_accept_network_initiated_session_finish ()

    gboolean
    mm_gdbus_modem_oma_call_accept_network_initiated_session_finish
                                   (MmGdbusModemOma *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_oma_call_accept_network_initiated_session()`.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_oma_call_accept_network_initiated_session()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_accept_network_initiated_session_sync ()

    gboolean
    mm_gdbus_modem_oma_call_accept_network_initiated_session_sync
                                   (MmGdbusModemOma *proxy,
                                    guint arg_session_id,
                                    gboolean arg_accept,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `AcceptNetworkInitiatedSession()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_oma_call_accept_network_initiated_session()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_session_id | Argument to pass with the method invocation. |
arg_accept | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_cancel_session ()

    void
    mm_gdbus_modem_oma_call_cancel_session
                                   (MmGdbusModemOma *proxy,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `CancelSession()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_oma_call_cancel_session_finish()` to get the result of the operation.

See `mm_gdbus_modem_oma_call_cancel_session_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_oma_call_cancel_session_finish ()

    gboolean
    mm_gdbus_modem_oma_call_cancel_session_finish
                                   (MmGdbusModemOma *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_oma_call_cancel_session()`.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_oma_call_cancel_session()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_cancel_session_sync ()

    gboolean
    mm_gdbus_modem_oma_call_cancel_session_sync
                                   (MmGdbusModemOma *proxy,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `CancelSession()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_oma_call_cancel_session()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_setup ()

    void
    mm_gdbus_modem_oma_call_setup (MmGdbusModemOma *proxy,
                                   guint arg_features,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Asynchronously invokes the `Setup()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_oma_call_setup_finish()` to get the result of the operation.

See `mm_gdbus_modem_oma_call_setup_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_features | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_oma_call_setup_finish ()

    gboolean
    mm_gdbus_modem_oma_call_setup_finish (MmGdbusModemOma *proxy,
                                          GAsyncResult *res,
                                          GError **error);

Finishes an operation started with `mm_gdbus_modem_oma_call_setup()`.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_oma_call_setup()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_setup_sync ()

    gboolean
    mm_gdbus_modem_oma_call_setup_sync (MmGdbusModemOma *proxy,
                                        guint arg_features,
                                        GCancellable *cancellable,
                                        GError **error);

Synchronously invokes the `Setup()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_oma_call_setup()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_features | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_start_client_initiated_session ()

    void
    mm_gdbus_modem_oma_call_start_client_initiated_session
                                   (MmGdbusModemOma *proxy,
                                    guint arg_session_type,
                                    GCancellable *cancellable,
                                    GAsyncReadyCallback callback,
                                    gpointer user_data);

Asynchronously invokes the `StartClientInitiatedSession()` D-Bus method on `proxy` . When the operation is finished, `callback` will be invoked in the thread-default main loop of the thread you are calling this method from (see `g_main_context_push_thread_default()`). You can then call `mm_gdbus_modem_oma_call_start_client_initiated_session_finish()` to get the result of the operation.

See `mm_gdbus_modem_oma_call_start_client_initiated_session_sync()` for the synchronous, blocking version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_session_type | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
callback | A GAsyncReadyCallback to call when the request is satisfied or `NULL`. |
user_data | User data to pass to `callback` . |

### mm_gdbus_modem_oma_call_start_client_initiated_session_finish ()

    gboolean
    mm_gdbus_modem_oma_call_start_client_initiated_session_finish
                                   (MmGdbusModemOma *proxy,
                                    GAsyncResult *res,
                                    GError **error);

Finishes an operation started with `mm_gdbus_modem_oma_call_start_client_initiated_session()`.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
res | The GAsyncResult obtained from the GAsyncReadyCallback passed to `mm_gdbus_modem_oma_call_start_client_initiated_session()`. |
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_call_start_client_initiated_session_sync ()

    gboolean
    mm_gdbus_modem_oma_call_start_client_initiated_session_sync
                                   (MmGdbusModemOma *proxy,
                                    guint arg_session_type,
                                    GCancellable *cancellable,
                                    GError **error);

Synchronously invokes the `StartClientInitiatedSession()` D-Bus method on `proxy` . The calling thread is blocked until a reply is received.

See `mm_gdbus_modem_oma_call_start_client_initiated_session()` for the asynchronous version of this method.

#### Parameters

proxy | A MmGdbusModemOmaProxy. |
arg_session_type | Argument to pass with the method invocation. |
cancellable | A GCancellable or `NULL`. | [nullable]
error | Return location for error or `NULL`. |

#### Returns

`TRUE` if the call succeeded, `FALSE` if `error` is set.

[skip]

### mm_gdbus_modem_oma_get_features ()

    guint
    mm_gdbus_modem_oma_get_features (MmGdbusModemOma *object);

Gets the value of the "Features" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemOma. |

#### Returns

The property value.

### mm_gdbus_modem_oma_get_session_state ()

    gint
    mm_gdbus_modem_oma_get_session_state (MmGdbusModemOma *object);

Gets the value of the "SessionState" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemOma. |

#### Returns

The property value.

### mm_gdbus_modem_oma_get_session_type ()

    guint
    mm_gdbus_modem_oma_get_session_type (MmGdbusModemOma *object);

Gets the value of the "SessionType" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemOma. |

#### Returns

The property value.

### mm_gdbus_modem_oma_get_pending_network_initiated_sessions ()

    GVariant *
    mm_gdbus_modem_oma_get_pending_network_initiated_sessions
                                   (MmGdbusModemOma *object);

Gets the value of the "PendingNetworkInitiatedSessions" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

The returned value is only valid until the property changes so on the client-side it is only safe to use this function on the thread where `object` was constructed. Use `mm_gdbus_modem_oma_dup_pending_network_initiated_sessions()` if on another thread.

[skip]

#### Parameters

object | A MmGdbusModemOma. |

#### Returns

The property value or `NULL` if the property is not set. Do not free the returned value, it belongs to `object` .

[transfer none][nullable]

### mm_gdbus_modem_oma_dup_pending_network_initiated_sessions ()

    GVariant *
    mm_gdbus_modem_oma_dup_pending_network_initiated_sessions
                                   (MmGdbusModemOma *object);

Gets a copy of the "PendingNetworkInitiatedSessions" D-Bus property.

Since this D-Bus property is readable, it is meaningful to use this function on both the client- and service-side.

[skip]

#### Parameters

object | A MmGdbusModemOma. |

#### Returns

The property value or `NULL` if the property is not set. The returned value should be freed with `g_variant_unref()`.

[transfer full][nullable]

## Types and Values

### MmGdbusModemOma

    typedef struct _MmGdbusModemOma MmGdbusModemOma;

Abstract interface type for the D-Bus interface org.freedesktop.ModemManager1.Modem.Oma.

### struct MmGdbusModemOmaIface

    struct MmGdbusModemOmaIface {
      GTypeInterface parent_iface;

      gboolean (*handle_accept_network_initiated_session) (
        MmGdbusModemOma *object,
        GDBusMethodInvocation *invocation,
        guint arg_session_id,
        gboolean arg_accept);

      gboolean (*handle_cancel_session) (
        MmGdbusModemOma *object,
        GDBusMethodInvocation *invocation);

      gboolean (*handle_setup) (
        MmGdbusModemOma *object,
        GDBusMethodInvocation *invocation,
        guint arg_features);

      gboolean (*handle_start_client_initiated_session) (
        MmGdbusModemOma *object,
        GDBusMethodInvocation *invocation,
        guint arg_session_type);

      guint  (*get_features) (MmGdbusModemOma *object);

      GVariant * (*get_pending_network_initiated_sessions) (MmGdbusModemOma *object);

      gint  (*get_session_state) (MmGdbusModemOma *object);

      guint  (*get_session_type) (MmGdbusModemOma *object);

      void (*session_state_changed) (
        MmGdbusModemOma *object,
        gint arg_old_session_state,
        gint arg_new_session_state,
        guint arg_session_state_failed_reason);
    };

Virtual table for the D-Bus interface org.freedesktop.ModemManager1.Modem.Oma.

#### Members

GTypeInterface `parent_iface`; | The parent interface. |
`handle_accept_network_initiated_session` () | Handler for the “handle-accept-network-initiated-session” signal. |
`handle_cancel_session` () | Handler for the “handle-cancel-session” signal. |
`handle_setup` () | Handler for the “handle-setup” signal. |
`handle_start_client_initiated_session` () | Handler for the “handle-start-client-initiated-session” signal. |
`get_features` () | Getter for the “features” property. |
`get_pending_network_initiated_sessions` () | Getter for the “pending-network-initiated-sessions” property. |
`get_session_state` () | Getter for the “session-state” property. |
`get_session_type` () | Getter for the “session-type” property. |
`session_state_changed` () | Handler for the “session-state-changed” signal. |

## Property Details

### The `“features”` property

      “features”                 guint

Represents the D-Bus property "Features".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemOma

Flags: Read / Write

Default value: 0

### The `“pending-network-initiated-sessions”` property

      “pending-network-initiated-sessions” GVariant *

Represents the D-Bus property "PendingNetworkInitiatedSessions".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemOma

Flags: Read / Write

Allowed values: GVariant<a(uu)>

Default value: NULL

### The `“session-state”` property

      “session-state”            int

Represents the D-Bus property "SessionState".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemOma

Flags: Read / Write

Default value: 0

### The `“session-type”` property

      “session-type”             guint

Represents the D-Bus property "SessionType".

Since the D-Bus property for this GObject property is readable but not writable, it is meaningful to read from it on both the client- and service-side. It is only meaningful, however, to write to it on the service-side.

Owner: MmGdbusModemOma

Flags: Read / Write

Default value: 0

## Signal Details

### The `“handle-accept-network-initiated-session”` signal

    gboolean
    user_function (MmGdbusModemOma       *object,
                   GDBusMethodInvocation *invocation,
                   guint                  arg_session_id,
                   gboolean               arg_accept,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `AcceptNetworkInitiatedSession()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_oma_complete_accept_network_initiated_session()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemOma. |
invocation | A GDBusMethodInvocation. |
arg_session_id | Argument passed by remote caller. |
arg_accept | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-cancel-session”` signal

    gboolean
    user_function (MmGdbusModemOma       *object,
                   GDBusMethodInvocation *invocation,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `CancelSession()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_oma_complete_cancel_session()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemOma. |
invocation | A GDBusMethodInvocation. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-setup”` signal

    gboolean
    user_function (MmGdbusModemOma       *object,
                   GDBusMethodInvocation *invocation,
                   guint                  arg_features,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `Setup()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_oma_complete_setup()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemOma. |
invocation | A GDBusMethodInvocation. |
arg_features | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“handle-start-client-initiated-session”` signal

    gboolean
    user_function (MmGdbusModemOma       *object,
                   GDBusMethodInvocation *invocation,
                   guint                  arg_session_type,
                   gpointer               user_data)

Signal emitted when a remote caller is invoking the `StartClientInitiatedSession()` D-Bus method.

If a signal handler returns `TRUE`, it means the signal handler will handle the invocation (e.g. take a reference to `invocation` and eventually call `mm_gdbus_modem_oma_complete_start_client_initiated_session()` or e.g. `g_dbus_method_invocation_return_error()` on it) and no order signal handlers will run. If no signal handler handles the invocation, the `G_DBUS_ERROR_UNKNOWN_METHOD` error is returned.

#### Parameters

object | A MmGdbusModemOma. |
invocation | A GDBusMethodInvocation. |
arg_session_type | Argument passed by remote caller. |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` if the invocation was handled, `FALSE` to let other signal handlers run.

Flags: Run Last

### The `“session-state-changed”` signal

    void
    user_function (MmGdbusModemOma *object,
                   int              arg_old_session_state,
                   int              arg_new_session_state,
                   guint            arg_session_state_failed_reason,
                   gpointer         user_data)

On the client-side, this signal is emitted whenever the D-Bus signal "SessionStateChanged" is received.

On the service-side, this signal can be used with e.g. `g_signal_emit_by_name()` to make the object emit the D-Bus signal.

#### Parameters

object | A MmGdbusModemOma. |
arg_old_session_state | Argument. |
arg_new_session_state | Argument. |
arg_session_state_failed_reason | Argument. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last